% Image edge detection using local entropy information
% Jiansheng Chen, Jingping He, and Guangda Su, "Combining Image Entropy 
% with the Pulse Coupled Neural Network in Edge Detection", ICIP 2010
function E = edgeEntropy(I)

    try
        I = rgb2gray(I);
    catch excetpion
    end    
    I = double(I);

    %window size is set to 2x2 by default
    jsd = zeros(size(I,1)-2, size(I,2)-2);
    %h = waitbar(0,'please wait...');
    for i = 1:size(jsd,1);
     %       waitbar(i/size(jsd,1));
            
        for j = 1:size(jsd,2);
            block = I(i:i+1, j:j+1);
            block = block - min(block(:)) +6;

            sub1 = block(:,1); sub2 = block(:,2);
            sub3 = block(1,:); sub4 = block(2,:);
            
            blockSum = sum(block(:));
            blockEntropy = -sum(sum((block/blockSum).*log2(block/blockSum)));
      
            Esub1 = -sum(sum((sub1./sum(sub1(:))).*log2(sub1./sum(sub1(:)))));
            Esub2 = -sum(sum((sub2./sum(sub2(:))).*log2(sub2./sum(sub2(:)))));
            Esub3 = -sum(sum((sub3./sum(sub3(:))).*log2(sub3./sum(sub3(:)))));
            Esub4 = -sum(sum((sub4./sum(sub4(:))).*log2(sub4./sum(sub4(:)))));
            
            jsd1 = (blockEntropy - Esub1*sum(sub1(:))/blockSum - Esub2*sum(sub2(:))/blockSum)*max(Esub1,Esub2);
            jsd2 = (blockEntropy - Esub3*sum(sub3(:))/blockSum - Esub4*sum(sub4(:))/blockSum)*max(Esub3,Esub4);

            jsd(i,j) = min([jsd1, jsd2]);
            
        end
    end
    %close(h);
    
    E = jsd>0.9; % use hard threshold intead of PCNN
end    